(define-module (ui root ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init))

(define (ui-generate)
  (form-update-value-list
    '("passwd_auto")
    (woo-read-first "/root")))

(define (ui-read)
  (form-update-value "passwd_1" "")
  (form-update-value "passwd_2" "")
  (form-update-value "passwd_auto" "")
  (form-update-value "auto" #f)
  (ui-generate)
  (update-effect))

(define (ui-write)
  (form-update-visibility "passwd_message" #f)
  (catch/message
    (lambda()
	(apply woo-write "/root"
		   'commit #t
		   'language (form-value "language")
		   (form-value-list '("auto" "passwd_1" "passwd_2" "passwd_auto")))
	(form-update-visibility "passwd_message" #t)
	(ui-read))))

(define (ui-key-read)
  (catch/message
   (lambda()
     (form-update-enum "key" (woo-list "/root/avail_key")))))

(define (ui-key-add)
  (call-with-form-file
      "key_file"
      (lambda(path)
        (catch/message
          (lambda()
            (woo-write "/root"
                       'add_key #t
                       'language (form-value "language")
                       'key_file path)
            (ui-key-read))))))

(define (ui-key-del)
  (catch/message
    (lambda()
        (woo-write "/root"
                   'del_key #t
                   'language (form-value "language")
                   'key (form-value "key"))
            (ui-key-read))))

(define (init)
  ;; password
  (effect-show "passwd_1" "auto" #f)
  (effect-show "passwd_2" "auto" #f)
  (effect-show "passwd_auto" "auto" #t)
  (effect-show "generate_button" "auto" #t)
  (init-effect)
  (ui-read)
  (form-bind "generate_button" "click" ui-generate)
  (form-bind "apply_button" "click" ui-write)
  ;; ssh keys
  (ui-key-read)
  (form-bind-upload "add_key_button" "click" "key_file" ui-key-add)
  (form-bind "del_key_button" "click" ui-key-del))
